TOOL.Category = "NPC Control"
TOOL.Name = "NPC Mover"
TOOL.Command = nil
TOOL.ConfigName = ""

TOOL.ClientConVar["npcsrun"] = "0"

mover_selectedNpcs = {}

local SpeakOnSelect = {}
SpeakOnSelect.npc_combine_s = "selected_combine.wav"
SpeakOnSelect.npc_metropolice = "selected_cop.wav"
SpeakOnSelect.npc_citizen = "selected_citizen.wav"

//Yoink!
//generic
//error
//undo
//hint
//cleanup

local function npc_doNotify( message, symbol, user )
  if SERVER then
    user:SendLua("GAMEMODE:AddNotify(\"" .. message .. "\", " .. symbol .. ", \"5\"); surface.PlaySound( \"ambient/water/drip" .. math.random(1, 4) .. ".wav\" )")
  end
end


if CLIENT then
  language.Add( "Tool_npc_mover_gun_name", "NPC Mover" )
  language.Add( "Tool_npc_mover_gun_desc", "Select and move multiple NPCs at once" )
  language.Add( "Tool_npc_mover_gun_0", "Left click to select an NPC, Right-click to tell them to move; Reload to un-select all" )
end

function TOOL:LeftClick( trace )
  if (trace.Hit && !trace.HitWorld) then
    if (trace.Entity:IsNPC()) then
      if (mover_selectedNpcs[trace.Entity] == nil) then
        //Select
        if (SpeakOnSelect[trace.Entity:GetClass()] != nil) then
          local ToSpeak = Sound( SpeakOnSelect[trace.Entity:GetClass()] )
          trace.Entity:EmitSound(ToSpeak)
        end
        mover_selectedNpcs[trace.Entity] = trace.Entity
        npc_doNotify("NPC Selected", "NOTIFY_GENERIC", self:GetOwner())
      else
        //Un-select
        mover_selectedNpcs[trace.Entity] = nil
        npc_doNotify("NPC un-selected", "NOTIFY_GENERIC", self:GetOwner())
      end
    end
    return true
  end
  return false
end

function TOOL:RightClick( trace )
  local runto = trace.HitPos
  if (GetConVarNumber("npc_control_allow_moving") == 1 || SinglePlayer()) then
    if (trace.HitWorld && !trace.HitSky) then
        for i, v in pairs(mover_selectedNpcs) do
          //Make sure it hasn't been un-selected
          local NPC = v
          if (NPC:IsValid() && SERVER) then
            if (self:GetClientNumber("npcsrun") == 0) then
              NPC:SetLastPosition( runto )
              NPC:SetSchedule( SCHED_FORCED_GO )
            else
              NPC:SetLastPosition( runto )
              NPC:SetSchedule( SCHED_FORCED_GO_RUN )
            end
          end 
        end
      return true
    end
  else
    npc_doNotify("This function is disabled on this server", "NOTIFY_ERROR", self:GetOwner())
  end
  return false
end

function TOOL:Reload( trace )
  mover_selectedNpcs = {}
  npc_doNotify("All NPCs un-selected", "NOTIFY_ERROR", self:GetOwner())
end

function TOOL.BuildCPanel(panel)
  panel:AddControl("Header", { Text = "NPC Mover", Description = "Used to move multiple NPCs at once" })
  panel:AddControl("CheckBox", { Label = "Run to position", Description = "Make selected NPCs run instead of walk to the position", Command = "npc_mover_gun_npcsrun" })
end
